Name:           libkml
Version:        1.3.0
Release:        15
Summary:        Reference implementation of OGC KML 2.2
License:        BSD
URL:            https://github.com/libkml/libkml
Source0:        https://github.com/libkml/libkml/archive/%{version}/libkml-%{version}.tar.gz

#See https://github.com/libkml/libkml/pull/239/commits/fe1f7ba4e76f156a160a6d3bbf28c3e224b3f43f
Patch0000:      0000-Fix-build-failure-due-to-failure-to-convert-pointer-to-bool.patch
#See https://github.com/libkml/libkml/pull/239/commits/77cf351a61f3683b74e07857ca77b5580d1cedf0
Patch0001:      0001-Fix-mistaken-use-of-std-cerr-instead-of-std-endl.patch
#See https://github.com/libkml/libkml/pull/239/commits/b728c0815edc06c826fb5be8cd25cbb7f3b816b3
Patch0002:      0002-Fix-python-tests.patch
#See https://github.com/libkml/libkml/pull/239/commits/2382618c2de489b860228b74283a581b4333030d
Patch0003:      0003-Correctly-build-and-run-java-test.patch
# Do not bytecompile sources during build process
Patch0004:      0004-libkml_dont-bytecompile.patch
#Disable crypt
Patch0005:      0005-libkml_define_NOUNCRYPT.patch

BuildRequires:  boost-devel cmake curl-devel expat-devel gcc-c++ gtest-devel java-devel junit make
BuildRequires:  minizip-devel python2-devel python3-devel swig uriparser-devel zlib-devel

Provides:       bundled(minizip) = 1.2.9

%description
This is Google's reference implementation of OGC KML 2.2. It also includes implementations of
Google's gx: extensions used by Google Earth, as well as several utility libraries for working
with other formats.

%package        devel
Summary:        Development documents for %{name}
Requires:       %{name} = %{version}-%{release} boost-devel expat-devel

%description    devel
The package provides libraries and header files for applications which developed with %{name}.

%package        java
Summary:        Java components of %{name}
Requires:       %{name} = %{version}-%{release}

%description    java
The package provides Java components of %{name}.

%package   -n   python2-%{name}
Summary:        Python2 components of %{name}
Requires:       %{name} = %{version}-%{release}
%{?python_provide:%python_provide python2-%{name}}

%description -n python2-%{name}
The package provides Python2 components of %{name}.

%package   -n   python3-%{name}
Summary:        Python3 components of %{name}
Requires:       %{name} = %{version}-%{release}
%{?python_provide:%python_provide python3-%{name}}

%description -n python3-%{name}
The package provides Python3 components of %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
mkdir python2
cd python2
%cmake -DBUILD_EXAMPLES=ON -DBUILD_TESTING=ON -DWITH_JAVA=ON -DWITH_PYTHON=ON -DWITH_SWIG=ON \
       -DCMAKE_INSTALL_DIR=%{_libdir}/cmake/%{name} -DINCLUDE_INSTALL_DIR=%{_includedir}/kml \
       -DJNI_INSTALL_DIR=%{_libdir}/%{name} \
       -DPYTHON_INCLUDE_DIR=%{_includedir}/python%{python2_version}/ \
       -DPYTHON_INSTALL_DIR=%{python2_sitearch} \
       -DPYTHON_LIBRARY=%{_libdir}/libpython%{python2_version}.so ..
%make_build
cd -

mkdir python3
cd python3
%cmake -DBUILD_EXAMPLES=OFF -DBUILD_TESTING=ON -DWITH_JAVA=OFF -DWITH_PYTHON=ON -DWITH_SWIG=ON \
       -DCMAKE_INSTALL_DIR=%{_libdir}/cmake/%{name} -DINCLUDE_INSTALL_DIR=%{_includedir}/kml \
       -DJNI_INSTALL_DIR=%{_libdir}/%{name} \
       -DPYTHON_INCLUDE_DIR=%{_includedir}/python%{python3_version}m/ \
       -DPYTHON_INSTALL_DIR=%{python3_sitearch} \
       -DPYTHON_LIBRARY=%{_libdir}/libpython%{python3_version}m.so ..
%make_build
cd -

%install
%make_install -C python2
%make_install -C python3

%check
cd python2
ctest -V
cd -

cd python3
ctest -V
cd -

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%license LICENSE
%doc AUTHORS README.md
%{_libdir}/*.so.*

%files devel
%doc examples
%{_includedir}/kml/
%{_libdir}/*.so
%{_libdir}/cmake/%{name}/
%{_libdir}/pkgconfig/%{name}.pc

%files java
%{_libdir}/%{name}/
%{_javadir}/*

%files -n python2-%{name}
%{python2_sitearch}/*

%files -n python3-%{name}
%{python3_sitearch}/*.{so,py}
%{python3_sitearch}/__pycache__/*.pyc

%changelog
* Sat Mar 7 2020 zhouyihang<zhouyihang1@huawei.com> - 1.3.0-15
- Pakcage init
